/* 
* Copyright (c) 2006, MessageVista Communication
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the MessageVista Communication nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY MESSAGEVISTA COMMUNICATION "AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE MESSAGEVISTA AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.IO;
using System.Security.Cryptography; 

namespace MessageVista.Security
{
	/// <summary>
	/// Summary description for Security.
	/// </summary>
	public class Security
	{
		private byte[] key = new byte[] {0x62, 0x78, 0x81, 0x6a, 0x24, 0x43, 
											0x65, 0x64, 0x73, 0x55, 0x64, 0x75, 0x66};
		public Security()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		
		public static byte[] Decrypt(byte[] cipherData, byte[] Key, byte[] IV) 
		{ 
			MemoryStream ms = new MemoryStream(); 
			Rijndael a = Rijndael.Create(); 
			a.Key = Key; 
			a.IV = IV; 
			CryptoStream cs = new CryptoStream(ms, a.CreateDecryptor(), CryptoStreamMode.Write); 			
			cs.Write(cipherData, 0, cipherData.Length); 
			cs.Close(); 
			byte[] decryptedData = ms.ToArray(); 
			return decryptedData; 
		}

		public string Decrypt(string cipherText, string Password) 
		{ 
			byte[] cipherBytes = Convert.FromBase64String(cipherText); 
			PasswordDeriveBytes pdb = new PasswordDeriveBytes(Password, key); 
			byte[] decryptedData = Decrypt(cipherBytes, 
				pdb.GetBytes(32), pdb.GetBytes(16)); 
			return System.Text.Encoding.Unicode.GetString(decryptedData); 
		}

		public string Encrypt(string clearText, string Password) 
		{ 
			byte[] clearBytes = System.Text.Encoding.Unicode.GetBytes(clearText); 
			PasswordDeriveBytes pdb = new PasswordDeriveBytes(Password, key); 
			byte[] encryptedData = Encrypt(clearBytes, pdb.GetBytes(32), pdb.GetBytes(16)); 
			return Convert.ToBase64String(encryptedData); 
		}

		public static byte[] Encrypt(byte[] clearData, byte[] Key, byte[] IV) 
		{ 
			MemoryStream ms = new MemoryStream(); 
			Rijndael alg = Rijndael.Create(); 
			alg.Key = Key; 
			alg.IV = IV; 
			CryptoStream cs = new CryptoStream(ms, alg.CreateEncryptor(), CryptoStreamMode.Write); 
			cs.Write(clearData, 0, clearData.Length); 
			cs.Close(); 
			byte[] encryptedData = ms.ToArray();
			return encryptedData; 
		} 
	}
}
